-- Pencil Paint 1.1 is a free app by Karl Noss. Visit karlnoss.com

-- Code adapted by Nevil Hopley 10&11 March 2012
-- Undo command and neater line tool, and adjusted the cursors added by Andy Kemp 11 March 2012
-- Note from Karl Noss: changes made by the previously mentioned 3rd parties have been cleaned up and incorporated into the main release.

platform.apilevel = '1.0'

-- In v0.6aknh penColor was set to black here, and showHelp was set to true. These were moved to on.escapeKey()

function on.paint(gc)	-- draws the current points on the screen

		setThickness()
		gc:setFont("sansserif", "r", 9)
	if showInfo == true then	
		gc:drawString("Pencil Paint is a free app written by Karl Noss.", 20, 20)
		gc:drawString("Visit karlnoss.com for more information.", 20, 35)
		gc:drawString("Press MENU for all options.", 20, 50)
	--	gc:drawString("Paypal donations welcomed at karlnoss.com", 20, 185)
		gc:drawString("Further additions by Nevil Hopley & Andy Kemp, 2012", 20, 200)
	end	
	if showHelp == true then
		gc:drawString("Press MENU for all options. Press U to undo.", 20, 50)
		gc:drawString("Click once on the paper to place or lift your pencil tip.", 20, 65)
		gc:drawString("When typing, click to make a text field, then click it to type.", 20, 80)
		gc:drawString("Single click away from the text to stop.", 20, 95)
		gc:drawString("Press Ctrl-S or SAVE to preserve your art.", 20, 110)
		gc:drawString("To clear the screen press ESC.", 20, 125)
		gc:drawString("To export your art, take a screen capture on a PC.", 20, 155)
	end
	
	-- draws axes
	if axes == "on" then
		gc:drawLine(0, 110, 320, 110)
		gc:drawLine(160, 0, 160, 220)
	end
	
	-- draws grid
	if grid == "on" then
		for i=0, 320, 10 do
			for j=0, 220, 10 do
				gc:fillArc(i - 1, j - 1, 2, 2, 0, 360)
			end
		end
	end

	-- draws Lines
	for i = 1, # xLineEnd, 1 do
		setColor(lineInk[i])	-- Calls the function that translates the string color value in the array to an RGB value to immediately use
		-- In v0.6aknh lines were made thicker through drawing them repeatedly beside each other. This has been replaced with a cleaner method.
		gc:drawLine(xLineStart[i], yLineStart[i], xLineEnd[i], yLineEnd[i])
	end
	
	-- draws preview of lines as mouse moves
	if penUp == false and utensil == "Ruler" then
		setColor(lineInk[#lineInk])
		gc:drawLine(xLineStart[#xLineStart], yLineStart[#yLineStart], cx, cy)	-- the preview line has the latest color; cx and cy are the cursor coordinates, set chronologically earlier.
	end
	
	-- draws Scribbles
	for i = 1, # xPaintEnd, 1 do
		setColor(paintInk[i])
		gc:drawLine(xPaintStart[i], yPaintStart[i], xPaintEnd[i], yPaintEnd[i])
	end
	
	gc:setFont("sansserif", "r", 11)
	-- draws Text
	for i = 1, # textStrings, 1 do
		setColor(textInk[i])
		gc:drawString(textStrings[i], xText[i], yText[i])
	end
	
	-- Paints indicator
	setColor(penColor)
	gc:fillRect(0, 0, 16, 16)
	gc:drawLine(0, 16, 16, 32)
	
end

function on.mouseDown(x, y)	-- when user clicks
	showHelp = false
	showInfo = false

	-- checks if GUI has been used
	if x < 16 and y < 16 and penUp then
		utensil = "Ruler"
		platform.window:invalidate()
		return
	elseif x < 16 and y > 16 and y < 34 and penUp then
		utensil = "Pencil"
		platform.window:invalidate()
		return
	elseif x < 16 and y > 35 and y < 51 and penUp then
		utensil = "Keyboard"
		platform.window:invalidate()
		return
	end
	
	if penUp == true then
		penUp = false	-- lowers pen
		
		if utensil == "Ruler" then  -- if drawing a line
		cursor.set("crosshair")
			table.insert(xLineStart, # xLineStart + 1, x)
			table.insert(yLineStart, # yLineStart + 1, y)
			table.insert(lineInk, # lineInk + 1, penColor)	-- adds an entry to the list of colors for the lines
			cx = x	-- cursor coords
			cy = y
			
		elseif utensil == "Pencil" then -- if scribbling a line
			cursor.set("pencil")
			table.insert(xPaintStart, # xPaintStart + 1, x)
			table.insert(yPaintStart, # yPaintStart + 1, y)
			table.insert(paintInk, # paintInk + 1, penColor)	-- again, adds a color to the list, this time for the paint, not the lines
			
		elseif utensil == "Keyboard" then -- if typing
			cursor.set("pointer")
			table.insert(xText, # xText + 1, x)
			table.insert(yText, # yText + 1, y + 19)
			table.insert(textInk, # textInk + 1, penColor)
			table.insert(events, # events + 1, utensil)
			
			-- listens for user text input
			fubar = D2Editor:newRichText()
			fubar:move(x, y)
			fubar:resize(1000, 40)
			
		end
		
	else
		penUp = true	-- raises the pen
		
		cursor.set("default")
		if utensil == "Ruler" then	-- if ending a line
			table.insert(xLineEnd, # xLineEnd + 1, x)
			table.insert(yLineEnd, # yLineEnd + 1, y)
			table.insert(events, # events + 1, utensil)
			
		elseif utensil == "Pencil" then -- if ending a scribble
			table.insert(xPaintEnd, # xPaintEnd + 1, x)
			table.insert(yPaintEnd, # yPaintEnd + 1, y)
			table.insert(events, # events + 1, utensil)
			
		elseif utensil == "Keyboard" then	-- if ending an input of text
			fubar:resize(1, 1)
			fubar:move(-200, -200)
			fubar:setReadOnly(true)
			--	tries to hide the editor
			
			table.insert(textStrings, # textStrings + 1, fubar:getText())
			--table.insert(xText, # xText, x)
			--table.insert(yText, # yText, y)
			
		end
		
		document.markChanged()
	end
	
	platform.window:invalidate()	-- shows new changes
end

function on.mouseMove(x, y)	-- when user moves mouse
	showHelp = false
	showInfo = false
	
	if utensil == "Ruler" then
		cx = x	-- cursor coords
		cy = y
	end
	
	if penUp then	-- If the pen is raised then moving will be useless
		cursor.set("default")
		return		--	So we return...
	end
	
	if utensil == "Ruler" then  -- if drawing a line
    	cursor.set("crosshair")
	elseif utensil == "Pencil" then -- if scribbling a line
		cursor.set("pencil")
	elseif utensil == "Keyboard" then -- if typing
    	cursor.set("pointer")	
	end
	
	if utensil == "Pencil" then	-- if continuing a scribble
		
		table.insert(paintInk, # paintInk + 1, penColor)
		
		-- connects previous dot to current place
		table.insert(xPaintEnd,  # xPaintEnd + 1, x)
		table.insert(yPaintEnd,  # yPaintEnd + 1, y)
	    table.insert(events, #events+1, utensil)

		
		-- sets up new first dot
		table.insert(xPaintStart, # xPaintStart + 1, x)
		table.insert(yPaintStart, # yPaintStart + 1, y)
		
	end
	
	platform.window:invalidate()	-- shows new changes
end

function on.tabKey()
	if utensil == "Pencil" then
		utensil = "Keyboard"
	elseif utensil == "Ruler" then
		utensil = "Pencil"
	elseif utensil == "Keyboard" then
		utensil = "Ruler"
	end
	
	platform.window:invalidate()
end

function on.charIn(ch)
	if ch ~= "u" then
		return
	end
    if events[#events] == "Pencil" then	-- if the last event is Pencil
    	if #xPaintStart ~= #xPaintEnd then	-- if not all lines finished
    		xPaintStart[#xPaintStart]=nil
   			yPaintStart[#yPaintStart]=nil
   		else
    		xPaintStart[#xPaintStart]=nil
    		yPaintStart[#yPaintStart]=nil
    		xPaintEnd[#xPaintEnd]=nil
    		yPaintEnd[#yPaintEnd]=nil
    		paintInk[#paintInk]=nil
    	end
    	
    	events[#events] = nil	-- erases last event now that points are gone
    	
    elseif events[#events] == "Ruler" then
    	xLineStart[#xLineStart]=nil
    	yLineStart[#yLineStart]=nil
    	xLineEnd[#xLineEnd]=nil
    	yLineEnd[#yLineEnd]=nil
    	lineInk[#lineInk]=nil
    	
    	events[#events] = nil
    	
    elseif events[#events] == "Keyboard" then
   		xText[#xText]=nil
   		yText[#yText]=nil
    	textStrings[#textStrings]=nil
    	textInk[#textInk]=nil
    	
    	events[#events] = nil
    end   
    
	penUp = true 
	platform.window:invalidate()
end

function on.save()
	saver = {}
	table.insert(saver, 1, xLineStart)
	table.insert(saver, 2, yLineStart)
	table.insert(saver, 3, xLineEnd)
	table.insert(saver, 4, yLineEnd)
	table.insert(saver, 5, xPaintStart)
	table.insert(saver, 6, yPaintStart)
	table.insert(saver, 7, xPaintEnd)
	table.insert(saver, 8, yPaintEnd)
	table.insert(saver, 9, xText)
	table.insert(saver, 10, yText)
	table.insert(saver, 11, textStrings)
	table.insert(saver, 12, penUp)
	table.insert(saver, 13, utensil)
	table.insert(saver, 14, lineInk)	-- new
	table.insert(saver, 15, paintInk)
	table.insert(saver, 16, textInk)
	table.insert(saver, 17, events)
	return saver
end

function on.restore(saver)
-- Line values
xLineStart = saver[1]
yLineStart = saver[2]
xLineEnd = saver[3]
yLineEnd = saver[4]

-- Scribble values
xPaintStart = saver[5]
yPaintStart = saver[6]
xPaintEnd = saver[7]
yPaintEnd = saver[8]

-- Text values
xText = saver[9]
yText = saver[10]
textStrings = saver[11]

penUp = saver[12]
utensil = saver[13]

-- Colors
lineInk = saver[14]
paintInk = saver[15]
textInk = saver[16]

events = saver[17] -- restore events list for undo


restored = true
end

function on.escapeKey()	-- resets the program to original values
	-- Line values
	xLineStart = {}
	yLineStart = {}
	xLineEnd = {}
	yLineEnd = {}
	
	-- Scribble values
	xPaintStart = {}
	yPaintStart = {}
	xPaintEnd = {}
	yPaintEnd = {}
	
	-- Text values
	xText = {}
	yText = {}
	textStrings = {}
	
	
	
	-- Colors
	lineInk = {}
	paintInk = {}
	textInk = {}
	penColor = "black"
	
	--order of events
	events={}
	
	penUp = true	-- Pen is not touching paper
	utensil = "Pencil"	
	restored = nil
	showHelp = false
	showInfo = true
	penThickness = "medium"

	platform.window:invalidate()
end

function setColor(theColor)		-- this function translated strings to RGB
	theColor = string.lower(theColor)	-- makes theColor lowercase
	platform.gc():setColorRGB(0,0,0) -- set black as default if nothing else valid is found
	if theColor == "blue" then platform.gc():setColorRGB(0,0,255)
	elseif theColor == "brown" then platform.gc():setColorRGB(165,42,42)
	elseif theColor == "cyan" then platform.gc():setColorRGB(0,255,255)
	elseif theColor == "darkblue" then platform.gc():setColorRGB(0,0,139)
	elseif theColor == "darkred" then platform.gc():setColorRGB(139,0,0)
	elseif theColor == "fuchsia" then platform.gc():setColorRGB(255,0,255)
	elseif theColor == "gold" then platform.gc():setColorRGB(255,215,0)
	elseif theColor == "gray" or theColor == "grey" then platform.gc():setColorRGB(127,127,127)
	elseif theColor == "green" then platform.gc():setColorRGB(0,128,0)
	elseif theColor == "lightblue" then platform.gc():setColorRGB(173,216,230)
	elseif theColor == "lightgreen" then platform.gc():setColorRGB(144,238,144)
	elseif theColor == "magenta" then platform.gc():setColorRGB(255,0,255)
	elseif theColor == "maroon" then platform.gc():setColorRGB(128,0,0)
	elseif theColor == "navyblue" then platform.gc():setColorRGB(159,175,223)
	elseif theColor == "orange" then platform.gc():setColorRGB(255,165,0)
	elseif theColor == "palegreen" then platform.gc():setColorRGB(152,251,152)
	elseif theColor == "pink" then platform.gc():setColorRGB(255,192,203)
	elseif theColor == "purple" then platform.gc():setColorRGB(128,0,128)
	elseif theColor == "red" then platform.gc():setColorRGB(255,0,0)
	elseif theColor == "royalblue" then platform.gc():setColorRGB(65,105,225)
	elseif theColor == "salmon" then platform.gc():setColorRGB(250,128,114)
	elseif theColor == "seagreen" then platform.gc():setColorRGB(46,139,87)
	elseif theColor == "silver" then platform.gc():setColorRGB(192,192,192)
	elseif theColor == "turquoise" then platform.gc():setColorRGB(64,224,208)
	elseif theColor == "violet" then platform.gc():setColorRGB(238,130,238)
	elseif theColor == "white" then platform.gc():setColorRGB(255,255,255)
	elseif theColor == "yellow" then platform.gc():setColorRGB(255,255,0)
	end	
end

function setThickness()
	if penThickness == "thin" then
		platform.gc():setPen("thin", "smooth")
	elseif penThickness == "medium" then
		platform.gc():setPen("medium", "smooth")
	else
		platform.gc():setPen("thick", "smooth")
	end
end

function on.help()
	showHelp = true
	showInfo = true
	platform.window:invalidate()
end

menu = {
	{"Colors",		
    	{"White", function() if not penUp then return end penColor="white" platform.window:invalidate() end},
		{"Black", function() if not penUp then return end penColor="black" platform.window:invalidate() end},
    	{"Brown", function() if not penUp then return end penColor="brown" platform.window:invalidate() end},
    	{"Red", function() if not penUp then return end penColor="red" platform.window:invalidate() end},
    	{"Orange", function() if not penUp then return end penColor="orange" platform.window:invalidate() end},                                       
    	{"Yellow", function() if not penUp then return end penColor="yellow" platform.window:invalidate() end},      
    	{"Green", function() if not penUp then return end penColor="green" platform.window:invalidate() end},
    	{"Blue", function() if not penUp then return end penColor="blue" platform.window:invalidate() end},
    	{"Violet", function() if not penUp then return end penColor="violet" platform.window:invalidate() end},                                       
    	{"Grey", function() if not penUp then return end penColor="grey" platform.window:invalidate() end},		
		{"Gold", function() if not penUp then return end penColor="gold" platform.window:invalidate() end},	
		{"Silver", function() if not penUp then return end penColor="silver" platform.window:invalidate() end},	
	},
	{"Tools",
        {"Ruler", function() if not penUp then return end utensil="Ruler" end},
        {"Pencil", function() if not penUp then return end utensil="Pencil" end},
        {"Text", function() if not penUp then return end utensil="Keyboard" end},
        {"Undo", function() if not penUp then return end on.backspaceKey() end},
	},
	{"Overlays",
        {"Axes On/Off", function() if not penUp then return end if axes=="on" then axes="off" else axes="on" end platform.window:invalidate() end},
        {"Grid On/Off", function() if not penUp then return end if grid=="on" then grid="off" else grid="on" end platform.window:invalidate() end},
	},   
	{"Thickness (All Lines)",
		{"Thin", function() if not penUp then return end if penThickness ~= "thin" then penThickness = "thin" end platform.window:invalidate() end},
		{"Medium", function() if not penUp then return end if penThickness ~= "medium" then penThickness = "medium" end platform.window:invalidate() end},
		{"Thick", function() if not penUp then return end if penThickness ~= "thick" then penThickness = "thick" end platform.window:invalidate() end},
	},
	{"Help",
		{"View Help", function() on.help() end}
	}	
}
toolpalette.register(menu)

if restored == nil then	-- this is checked when program first runs
	on.escapeKey()
end